"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Warlock = Warlock;
const warlock_service_1 = require("./warlock.service");
function Warlock(lockKey, ttl) {
    return function (_target, _propertyKey, descriptor) {
        const originalMethod = descriptor.value;
        console.log(lockKey, ttl);
        descriptor.value = async function (...args) {
            const warlockService = warlock_service_1.WarlockService.getInstance();
            const hasLock = await warlockService.acquireLock(lockKey, ttl);
            if (hasLock) {
                try {
                    const result = await originalMethod.apply(this, args);
                    return result;
                }
                finally {
                    await warlockService.releaseLock(lockKey);
                }
            }
        };
        return descriptor;
    };
}
//# sourceMappingURL=warlock.decorator.js.map