"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var WarlockModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WarlockModule = void 0;
const common_1 = require("@nestjs/common");
const ioredis_1 = __importDefault(require("ioredis"));
const warlock_service_1 = require("./warlock.service");
let WarlockModule = WarlockModule_1 = class WarlockModule {
    static forRoot(redisUrl) {
        this.redisClient = new ioredis_1.default(redisUrl);
        return {
            module: WarlockModule_1,
            providers: [
                {
                    provide: "WARLOCK_CLIENT",
                    useValue: this.redisClient,
                },
                warlock_service_1.WarlockService,
            ],
            exports: [warlock_service_1.WarlockService],
        };
    }
    static forRootAsync(options) {
        return {
            module: WarlockModule_1,
            providers: [
                {
                    provide: "WARLOCK_CLIENT",
                    useFactory: async (...args) => {
                        const redisUrl = await options.useFactory(...args);
                        this.redisClient = new ioredis_1.default(redisUrl);
                        return this.redisClient;
                    },
                    inject: options.inject || [],
                },
                warlock_service_1.WarlockService,
            ],
            exports: [warlock_service_1.WarlockService],
        };
    }
    static getRedisClient() {
        if (!this.redisClient) {
            throw new Error("Redis client is not initialized. Did you forget to call forRoot or forRootAsync?");
        }
        return this.redisClient;
    }
};
exports.WarlockModule = WarlockModule;
exports.WarlockModule = WarlockModule = WarlockModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], WarlockModule);
//# sourceMappingURL=warlock.module.js.map