"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var WarlockService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.WarlockService = void 0;
const common_1 = require("@nestjs/common");
const ioredis_1 = __importDefault(require("ioredis"));
let WarlockService = WarlockService_1 = class WarlockService {
    constructor(redis) {
        this.redis = redis;
        console.log('Redis client injected:', this.redis);
        this.lockValue = `${process.pid}-${Date.now()}`;
    }
    onModuleInit() {
        WarlockService_1.instance = this;
    }
    static getInstance() {
        if (!WarlockService_1.instance) {
            throw new Error('WarlockService is not initialized. Ensure the service is part of a module.');
        }
        return WarlockService_1.instance;
    }
    async acquireLock(lockKey, ttl) {
        const result = await this.redis.set(lockKey, this.lockValue, "EX", ttl, "NX");
        return result === "OK";
    }
    async isLeader(lockKey) {
        const currentValue = await this.redis.get(lockKey);
        return currentValue === this.lockValue;
    }
    async releaseLock(lockKey) {
        const currentValue = await this.redis.get(lockKey);
        if (currentValue === this.lockValue) {
            await this.redis.del(lockKey);
        }
    }
};
exports.WarlockService = WarlockService;
exports.WarlockService = WarlockService = WarlockService_1 = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)('WARLOCK_CLIENT')),
    __metadata("design:paramtypes", [ioredis_1.default])
], WarlockService);
//# sourceMappingURL=warlock.service.js.map